"use strict";
cc._RF.push(module, 'ed2531S9CxAa60ZvAZsqH57', 'Rotator');
// scripts/Rotator.ts

"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var Rotator = /** @class */ (function (_super) {
    __extends(Rotator, _super);
    function Rotator() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.box3d = null;
        _this.camera = null;
        _this._direction = cc.v3();
        return _this;
    }
    Rotator.prototype.onLoad = function () {
        this.node.on(cc.Node.EventType.MOUSE_MOVE, this._mouseUp, this);
    };
    Rotator.prototype.start = function () {
    };
    Rotator.prototype.update = function (dt) {
        this._rotateToTarget();
    };
    Rotator.prototype._mouseUp = function (e) {
        var mouse = e.getLocation();
        var mouseLocation = cc.v3(mouse.x, mouse.y);
        var box3dLocation = this.node.convertToWorldSpaceAR(this.box3d.position);
        console.log("ML: " + mouseLocation.x + "," + mouseLocation.y + " BL: " + box3dLocation.x + "," + box3dLocation.y);
        this._direction = mouseLocation.subtract(box3dLocation);
    };
    Rotator.prototype._rotateToTarget = function () {
        var radianAngle = Math.atan2(this._direction.y, this._direction.x);
        this.box3d.angle = cc.misc.radiansToDegrees(radianAngle);
    };
    __decorate([
        property(cc.Node)
    ], Rotator.prototype, "box3d", void 0);
    __decorate([
        property(cc.Camera)
    ], Rotator.prototype, "camera", void 0);
    Rotator = __decorate([
        ccclass
    ], Rotator);
    return Rotator;
}(cc.Component));
exports.default = Rotator;

cc._RF.pop();